package net.t2code.t2codelib.SPIGOT.api.bungeePlayers;

import lombok.Getter;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.plugin.messaging.PluginMessageListener;
import org.jetbrains.annotations.NotNull;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class T2C_BungeePlayers implements PluginMessageListener {
    @Getter
    private static List<String> bungeePlayers = new ArrayList<>();

    @Override
    public void onPluginMessageReceived(@NotNull String channel, @NotNull Player player, byte[] message) {
        DataInputStream stream = new DataInputStream(new ByteArrayInputStream(message));
        T2C_Debug.debug(T2C_Main.getPlugin(), "stream: " + stream.toString());
        try {
            T2C_BngeePlayersEnum subChannel = T2C_BngeePlayersEnum.valueOf(stream.readUTF());
            String input = stream.readUTF();
            String uuid = stream.readUTF();
            T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage received channel: " + channel);
            T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage received subChannel: " + subChannel.name());
            T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage received input: " + input);
            T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage received input2/uuid: " + uuid);
            switch (subChannel) {
                case JOIN:
                    bungeePlayers.add(input);
                    break;
                case QUIT:
                    bungeePlayers.remove(input);
                    break;
                case GIVEALL:
                    if (!T2C_LibConfig.VALUES.serverUUID.getValue().equals(uuid)) {
                        return;
                    }
                    bungeePlayers.clear();
                    String[] in = input.split(";");
                    bungeePlayers.addAll(Arrays.asList(in));
                    break;
                case CLEAR:
                    bungeePlayers.clear();
                    break;
            }
        } catch (IOException e) {
            T2C_Send.sendException(e, T2C_Main.getPlugin().getLogger());
        }
    }

    public static void callAllBungeePlayers() {
        if (Bukkit.getOnlinePlayers().isEmpty()) {
            Bukkit.getScheduler().runTaskLaterAsynchronously(T2C_Main.getPlugin(), new Runnable() {
                @Override
                public void run() {
                    callAllBungeePlayers();
                }
            }, 20L);
            return;
        }
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            output.writeUTF(T2C_BngeePlayersEnum.GIVEALL.name());
            output.writeUTF(T2C_LibConfig.VALUES.serverUUID.getValue().toString());
        } catch (IOException e) {
            T2C_Send.sendException(e, T2C_Main.getPlugin().getLogger());
        }

        for (Player player : Bukkit.getOnlinePlayers()) {
            player.sendPluginMessage(T2C_Main.getPlugin(), T2C_Util.getPluginChannel_ProxyOnlinePlayers(), stream.toByteArray());
            T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage received channel: " + T2C_Util.getPluginChannel_ProxyOnlinePlayers());
            T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage send subChannel: " + T2C_BngeePlayersEnum.GIVEALL.name());
            T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage send output/uuid: " + T2C_LibConfig.VALUES.serverUUID.getValue().toString());
            return;
        }
    }
}
