package net.t2code.t2codelib.SPIGOT.api.messages;

import net.t2code.t2codelib.SPIGOT.api.update.T2C_UpdateAPI;
import net.t2code.t2codelib.util.T2C_GenerateFrame;
import net.t2code.t2codelib.util.T2C_UpdateWebData;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class T2C_Template {


    public static Long onLoadHeader(String prefix, List<String> autor, String version, String spigot, String discord) {
        return onLoadHeader(prefix, autor, version, spigot, discord, null, null);
    }

    public static Long onLoadHeader(String prefix, List<String> autor, String version, String spigot, String discord, Boolean isPremium, Boolean isVerify) {
        Long long_ = System.currentTimeMillis();

        for (String s : T2C_Util.getLoadLogo()) {
            T2C_Send.console(prefix + " "+ T2C_GenerateFrame.getCOLOR_CODE() + s);
        }
        T2C_Send.sendStartTextCenter(prefix, "§2Author §6" + String.valueOf(autor).replace("[", "").replace("]", ""), false);
        T2C_Send.sendStartTextCenter(prefix, "§2Version: §6" + version, false);
        T2C_Send.sendStartTextCenter(prefix, "§2Spigot: §6" + spigot, false);
        T2C_Send.sendStartTextCenter(prefix, "§2Discord: §6" + discord, false);
        if (isPremium != null) {
            if (isPremium) {
                T2C_Send.sendStartTextCenter(prefix, "§6Premium: §2true", false);
            } else T2C_Send.sendStartTextCenter(prefix, "§6Premium: §4false", false);
            if (isVerify != null) {
                if (isVerify) {
                    T2C_Send.sendStartTextCenter(prefix, "§6Verify: §2true", false);
                } else T2C_Send.sendStartTextCenter(prefix, "§6Verify: §4false", false);
            } else T2C_Send.sendStartTextCenter(prefix, "§6Verify: §4false", false);
        }

        onLoadSeparateStroke(prefix);
        if (version.toLowerCase().contains("dev") || version.toLowerCase().contains("snapshot") || version.toLowerCase().contains("beta")) {
            T2C_Send.sendStartTextCenter(prefix, "", false);
            T2C_Send.sendStartTextCenter(prefix, "", false);
            T2C_Send.sendStartTextCenter(prefix, "§eYou are running §4" + version + " §eof §4" + prefix + "§e!", false);
            T2C_Send.sendStartTextCenter(prefix, "§eSome features may not be working as expected.", false);
            T2C_Send.sendStartTextCenter(prefix, "§ePlease report all bugs here: http://dc.t2code.net", false);
            T2C_Send.sendStartTextCenter(prefix, "§4UpdateChecker & bStats may be disabled!", false);
            T2C_Send.sendStartTextCenter(prefix, "", false);
            T2C_Send.sendStartTextCenter(prefix, "", false);
            onLoadSeparateStroke(prefix);

            try {
                Thread.sleep(2000);
            } catch (Exception ignored) {
            }

        }

        return long_;
    }

    public static void onLoadSeparateStroke(String prefix) {
        T2C_Send.console(prefix + " " + T2C_GenerateFrame.getCOLOR_CODE() + T2C_GenerateFrame.getSTROKE());
    }

    public static void onLoadFooter(String prefix, Long long_) {
        onLoadSeparateStroke(prefix);
        T2C_Send.sendStartTextCenter(prefix, "§2Plugin loaded successfully." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms", false);
        T2C_Send.console(prefix + " " + T2C_GenerateFrame.getCOLOR_CODE() + T2C_GenerateFrame.getBOTTOM_BORDER());
    }

    public static void onDisable(String prefix, Plugin plugin) {
        T2C_Send.console(T2C_Send.getFrameCenter(prefix, true, " §2Version: §6" + plugin.getDescription().getVersion(), "§2Autors: §6" + String.valueOf(plugin.getDescription().getAuthors())
                .replace("[", "").replace("]", ""), " §4Plugin successfully disabled. "));
    }

    public static void sendInfo(CommandSender sender, Plugin plugin, int spigotID, String discord, Boolean premiumVerified, String text) {
        String pluginVersion = plugin.getDescription().getVersion();
        String publicVersion = "";
        boolean update;
        String stNVersion;
        T2C_UpdateWebData webData;
        try {
            webData = T2C_UpdateAPI.pluginVersions.get(plugin.getName()).webData;
        } catch (Exception ex) {
            webData = null;
        }

        if (webData != null) {
            publicVersion = T2C_UpdateAPI.pluginVersions.get(plugin.getName()).webData.getVersion();
            update = !publicVersion.equalsIgnoreCase(pluginVersion);

        } else {
            update = false;
        }

        boolean player = sender instanceof Player;
        String stPlugin = "<dark_red>║</dark_red> <yellow>Plugin:</yellow> <gold>[pl]</gold>".replace("[pl]", plugin.getName());
        String stVersion = "<dark_red>║</dark_red> <yellow>Version:</yellow> <gold>[ver]</gold>".replace("[ver]", pluginVersion);
        String stAutor = "<dark_red>║</dark_red> <yellow>Autor(s):</yellow> <gold>[autor]</gold>".replace("[autor]", plugin.getDescription().getAuthors().toString());

        String stUpdate = "<dark_red>║</dark_red> <yellow>New version available:</yellow> [up]".replace("[up]", webData != null ? update ?
                "<dark_green>YES</dark_green>" : "<red>no</red>" : "<b><dark_red>It could not be checked for updates!</dark_red></b>");
        stNVersion = update ? "<br><dark_red>║</dark_red> <yellow>Newest Version:</yellow> <gold>[newVersion]</gold>".replace("[newVersion]", player ? "<hover:show_text:'<yellow>Click for the update information</yellow>'><click:run_command:'/t2code updateinfo " + plugin.getName() + "'>" + publicVersion + "</click></hover>" : publicVersion) : "";
        String stLink = getString(spigotID, discord, player);
        String pr = premiumVerified != null ? "<br><dark_red>║</dark_red> <yellow>Premium verified:</yellow> [pr]".replace("[pr]",
                premiumVerified ? "<dark_green>YES</dark_green>" : "<red>NO</red>") : "";

        String stMSG = text == null || text.isEmpty() ? "" : "<br><dark_red>║</dark_red> " + text;
        T2C_Send.sender(sender, "<br><dark_red>╔════════════════════════════════</dark_red>"
                + "<br>" + stPlugin
                + "<br>" + stVersion
                + stMSG
                + "<br>" + stAutor
                + "<br>" + stUpdate
                + stNVersion
                + "<br>" + stLink
                + pr
                + "<br><dark_red>╚════════════════════════════════</dark_red>");
    }

    private static @NotNull String getString(int spigotID, String discord, boolean player) {
        String stLinkPlayer = "<dark_red>║</dark_red> <yellow><hover:show_text:'<green>Go to the Spigot page</green>'><click:open_url:'[slink]'>Spigot</click></hover></yellow> "
                .replace("[slink]", "https://www.spigotmc.org/resources/" + spigotID)
                + "<dark_red>-</dark_red> <dark_purple><hover:show_text:'<green>Go to the T2Code Support Discord</green>'><click:open_url:'[dlink]'>Discord</click></hover></dark_purple>"
                .replace("[dlink]", discord);
        String stLinkConsole = "<dark_red>║</dark_red> <yellow>Spigot:</yellow> <gold>https://www.spigotmc.org/resources/" + spigotID + "</gold>"
                + "<br><dark_red>║</dark_red> <yellow>Discord:</yellow> <gold>" + discord + "</gold>";
        return player ? stLinkPlayer : stLinkConsole;
    }

    public static void sendInfo(CommandSender sender, Plugin plugin, int spigotID, String discord, String text) {
        sendInfo(sender, plugin, spigotID, discord, null, text);
    }
}