package net.t2code.t2codelib.SPIGOT.api.update;

import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_UpdateType;
import net.t2code.t2codelib.util.T2C_UpdateObject;
import net.t2code.t2codelib.util.T2C_UpdateWebData;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.HashMap;

public class T2C_UpdateAPI {
    public static HashMap<String, T2C_UpdateObject> pluginVersions = new HashMap<>();

    public static void join(Plugin plugin, String prefix, String perm, Player player, Integer spigotID, String discord) {
        if (pluginVersions.get(plugin.getName()) == null) {
            Bukkit.getScheduler().runTaskLaterAsynchronously(T2C_Main.getPlugin(), () -> join(plugin, prefix, perm, player, spigotID, discord), 2 * 20L);
            return;
        }

        if (!pluginVersions.get(plugin.getName()).updateCheckOnJoin) {
            return;
        }
        if (!player.hasPermission(perm) && !player.isOp()) {
            return;
        }
        if (pluginVersions.get(plugin.getName()) == null) {
            new BukkitRunnable() {
                @Override
                public void run() {
                    join(plugin, prefix, perm, player, spigotID, discord);
                }
            }.runTaskLaterAsynchronously(plugin, 20L);
            return;
        }
        T2C_UpdateWebData webData = pluginVersions.get(plugin.getName()).webData;
        if (!pluginVersions.get(plugin.getName()).updateAvailable) return;
        new BukkitRunnable() {
            @Override
            public void run() {
                sendUpdateMsg(prefix, webData, discord, plugin, player);
            }
        }.runTaskLaterAsynchronously(T2C_Main.getPlugin(), 200L);
    }

    public static void sendUpdateMsg(String prefix, T2C_UpdateWebData webData, String discord, Plugin plugin, Player player) {
        String publicVersion = webData.getVersion();
        String pluginVersion = plugin.getDescription().getVersion();
        if (!pluginVersions.get(plugin.getName()).updateAvailable) {
            return;
        }
        String updateStatusVersion = getUpdateType(webData);
        String st = "[prefix]<br>" +
                "<click:open_url:'[link]'><hover:show_text:'<color:#6e90ff>You can download it here: <yellow>[link]</yellow></color>'>[prefix] <color:#6e90ff>A new</color> [value] <color:#6e90ff>version was" +
                " found!</color></hover></click><br>" +
                "<click:open_url:'[link]'><hover:show_text:'<color:#6e90ff>You can download it here: <yellow>[link]</yellow></color>'>[prefix] <red>[plv]</red> <gray>-></gray> " +
                "<green>[puv]</green></hover></click><br>" +
                "<click:open_url:'[dc]'><hover:show_text:'<yellow>[dc]</yellow>'>[prefix] <color:#6e90ff>You can find more information on Discord.</color></hover></click><br>" +
                "[prefix] <color:#ff9499><hover:show_text:'<red>Click for more information</red>'><click:run_command:'/t2c updateinfo " + plugin.getName() + "'>Update information</click></hover></color><br>" +
                "[prefix]";

        T2C_Send.player(player, st.replace("[prefix]", prefix).replace("[value]", updateStatusVersion).replace("[link]", webData.getUpdateUrl())
                .replace("[plv]", pluginVersion).replace("[puv]", publicVersion).replace("[dc]", discord));
    }

    public static void sendUpdateMsg(String prefix, String discord, T2C_UpdateWebData webData, Plugin plugin) {
        String publicVersion = webData.getVersion();
        String pluginVersion = plugin.getDescription().getVersion();
        String updateStatusVersion = getUpdateType(webData);
        String s1 = "<color:#6e90ff>A new [value] version was found!</color>".replace("[value]", updateStatusVersion);
        String s2 = "<color:#6e90ff>Your version: <red>" + pluginVersion + "</red> <gray>-</gray> Current version:</color> <green>" + webData.getVersion() + "</green>";
        String s3 = "<color:#6e90ff>You can download it here:</color> <yellow>" + webData.getUpdateUrl() + "</yellow>";
        String s4 = "<color:#6e90ff>You can find more information on Discord:</color> <yellow>" + discord + "</yellow>";

        T2C_Send.console(T2C_Send.getFrameCenter(prefix, true, s1, s2, s3, s4));
    }

    public static String updateInfo(String[] args, Boolean player) {
        T2C_UpdateObject object;
        try {
            object = T2C_UpdateAPI.pluginVersions.get(args[1]);
        } catch (Exception e) {
            return T2C_Util.getPrefix() + " <red>The plugin <yellow>" + args[1] + "</yellow> is not registered in the update checker of T2Code!</red>";
        }
        if (object == null) return T2C_Util.getPrefix() + " <red>The plugin <yellow>" + args[1] + "</yellow> is not registered in the update checker of T2Code!</red>";
        T2C_UpdateWebData webData = object.webData;
        if (webData == null) {
            return T2C_Util.getPrefix() + " <b><dark_red>It could not be checked for updates with the plugin <yellow>" + args[1] + "</yellow>!</dark_red></b>";
        }
        String pluginName = T2C_UpdateAPI.pluginVersions.get(args[1]).pluginName;
        String pluginVersion = T2C_UpdateAPI.pluginVersions.get(args[1]).pluginVersion;

        String updateTitle = webData.getUpdateTitle();
        String publicVersion = webData.getVersion();
        String updateType = getUpdateType(webData);

        String updateAt = webData.getPublishedAt();
        String updateUpdate = webData.getUpdateUrl();
        String updateDescription = webData.getUpdateDescription();

        String pluginNameString = "<br><dark_red>║</dark_red> <color:#6e90ff>Plugin:</color> <color:#5eff89>" + pluginName + "</color>";
        String pluginVersionString = "<br><dark_red>║</dark_red> <color:#6e90ff>Your version:</color> <color:#5eff89>" + pluginVersion + "</color>";
        String updateInfoString = "<br><dark_red>║</dark_red> <color:#09ff00>[value]:</color>";
        String updateTitleString = "<br><dark_red>║</dark_red> <color:#6e90ff>Title:</color> <color:#5eff89>" + updateTitle + "</color>";
        String updateVersionString = "<br><dark_red>║</dark_red> <color:#6e90ff>Version:</color> <color:#5eff89>" + publicVersion + "</color>";
        String updateAtString = "<br><dark_red>║</dark_red> <color:#6e90ff>Published on:</color> <color:#5eff89>" + updateAt + "</color>";
        String updateTypeString = "<br><dark_red>║</dark_red> <color:#6e90ff>Version type:</color> <color:#5eff89>" + updateType + "</color>";

        String updateButton;
        if (player) {
            updateButton = "<br><dark_red>║</dark_red> <color:#5eff89><hover:show_text:'<gold>" + updateUpdate + "</gold>'><click:open_url:'" + updateUpdate
                    + "'>Download</click></hover></color> <dark_gray>|</dark_gray> <color:#ff9499><hover:show_text:'" + updateDescription + "'><click:open_url:'" + webData.getGitURL() + "'>Update Description</click></hover></color>";
        } else updateButton = "<br><dark_red>║</dark_red> <color:#5eff89>Download:</color> <gold>" + updateUpdate + "</gold>";

        String text;

        text = "<br><dark_red>╔══════════════════════</dark_red>";
        text = text + pluginNameString;
        text = text + pluginVersionString;
        text = text + updateInfoString.replace("[value]", object.updateAvailable ? "Update available" : "Info about your version");
        if (!updateTitle.equals("OLD")) text = text + updateTitleString;
        if (object.updateAvailable) text = text + updateVersionString;
        if (!updateTitle.equals("OLD")) text = text + updateAtString;
        if (!updateTitle.equals("OLD")) text = text + updateTypeString;
        text = text + updateButton;

        if (updateTitle.equals("OLD")) text = text + "<br><dark_gray>This plugin does not have the new update checker yet, so there is no exact update / " +
                "version information available!</dark_gray>";

        text = text + "<br><dark_red>╚══════════════════════</dark_red>";

        return text;
    }

    public static void onUpdateCheck(Plugin plugin, String prefix, String gitKey, Integer spigotID, String discord, Boolean updateCheckOnJoin, Boolean seePreReleaseUpdates, Integer timeInterval) {
        if ((boolean) T2C_LibConfig.VALUES.updateCheckFullDisable.getValue()) return;
        new T2C_UpdateCheckerGit((JavaPlugin) plugin, prefix, gitKey, spigotID, discord, updateCheckOnJoin, seePreReleaseUpdates, timeInterval);
    }

    private static String getUpdateType(T2C_UpdateWebData webData) {
        String updateType;
        String publicVersion = webData.getVersion();
        if (webData.isPreRelease()) {
            updateType = T2C_UpdateType.PRERELEASE.text;
            if (publicVersion.toLowerCase().contains("dev")) {
                updateType = T2C_UpdateType.DEVELOPMENT.text;
            }
            if (publicVersion.toLowerCase().contains("beta")) {
                updateType = T2C_UpdateType.BETA.text;
            }
            if (publicVersion.toLowerCase().contains("snapshot")) {
                updateType = T2C_UpdateType.SNAPSHOT.text;
            }
        } else updateType = T2C_UpdateType.STABLE.text;
        return updateType;
    }
}
