// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.api.yaml;

import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class T2C_ConfigWriter {

    private static FileConfiguration config;

    public static void createConfig(String prefix, File configFile, T2C_ConfigItem[] values, boolean isReload, String... header) {
        long long_ = System.currentTimeMillis();
        boolean exist = configFile.exists();
        if (!exist) {
            configFile.getParentFile().mkdir();
            try {
                configFile.createNewFile();
            } catch (IOException e) {
                T2C_Send.sendException(e, T2C_Main.getPlugin().getLogger());
                return;
            }
        } else exist = true;

        config = YamlConfiguration.loadConfiguration(configFile);
        Map<String, List<String>> comments = new LinkedHashMap<>();

        T2C_LanguageEnum lang = null;
        String lp = values[0].getLanguagePath();

        try {
            lang = T2C_LanguageEnum.valueOf(lp);
        } catch (Exception ignore) {
        }
        if (lang == null) {
            try {
                lang = T2C_LanguageEnum.valueOf(config.getString(lp.replace(".yml", "")));
            } catch (Exception e) {
                lang = T2C_LanguageEnum.english;
            }
        }

        for (T2C_ConfigItem item : values) {
            if (item.getForceSet() || !exist) {
                config.addDefault(item.getPath(), item.getValue());

                List<String> commandList = item.getComments().get(lang);
                if (commandList != null) {
                    comments.put(item.getPath(), commandList);
                }
            }
        }


        // Copy default values if they are missing
        config.options().copyDefaults(true);

        T2C_YmlWriter.saveConfigWithComments(configFile, config, comments, false, header);
        readConfig(prefix, configFile, config, values, isReload, long_);
    }

    private static void readConfig(String prefix, File configFile, FileConfiguration config, T2C_ConfigItem[] values, boolean isReload, long long_) {
        for (T2C_ConfigItem value : values) {
            value.setValue(config.get(value.getPath()));
        }
        T2C_Send.sendStartTextCenter(prefix, "§2Load successfully: §7" + configFile.getPath() + "/" + config.getName().replace("/","")+" §7- §e"+ (System.currentTimeMillis() - long_) + "ms", isReload);
       // T2C_Send.sendStartTextCenter(prefix, "§2Has been successfully created / updated §7- §e" + (System.currentTimeMillis() - long_) + "ms", isReload);
        //T2C_Send.sendStartTextCenter(prefix, "", isReload);
        //T2C_Send.sendStartTextCenter(Util.getPrefix(), "§2opWhitelist.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms",isReload);
    }
}
