// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.api.yaml;

import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.List;
import java.util.Map;

public class T2C_YmlWriter {
    public static void saveConfigWithComments(File file, FileConfiguration config, Map<String, List<String>> comments, boolean oneListToString,String... headers) {
        try {
            StringBuilder configContent = new StringBuilder();
            for (String h : headers) {
                configContent.append(h).append("\n");
            }
            configContent.append("\n");
            addSection(config, comments, configContent, "", 0,oneListToString);

            // Write the content to the file
            Files.write(file.toPath(), configContent.toString().getBytes());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    protected static void addSection(ConfigurationSection section, Map<String, List<String>> comments, StringBuilder builder, String prefix, int indentLevel, boolean oneListToString) {
        String indent = "  ".repeat(indentLevel);

        for (String key : section.getKeys(false)) {
            String fullKey = prefix.isEmpty() ? key : prefix + "." + key;
            Object value = section.get(key);

            // Add comment if it exists for this key
            List<String> commentList = comments.get(fullKey);
            if (commentList != null) {
                for (String c : commentList) {
                    if (c.isEmpty()) {
                        builder.append(indent).append(c).append("\n");
                    } else builder.append(indent).append("# ").append(c).append("\n");
                }
            }

            // Check if the value is a section (nested map)
            if (value instanceof ConfigurationSection) {
                // Correctly add the section
                builder.append(indent).append(key).append(":\n");
                addSection((ConfigurationSection) value, comments, builder, fullKey, indentLevel + 1, oneListToString);
            } else {
                // Add value with proper indentation
                // builder.append(indent).append(key).append(": ").append(value).append("\n");
                if (value instanceof List) {
                    List<?> list = (List<?>) value;

                    if (oneListToString && list.size() == 1) {
                        for (Object s : list) {
                            builder.append(indent).append(key).append(": \"").append(s).append("\"\n");
                        }
                        continue;
                    }
                    if (list.isEmpty()) {
                        builder.append(indent).append(key).append(": []").append("\n");
                        continue;
                    }
                    builder.append(indent).append(key).append(": ").append("\n");
                    for (Object s : list) {
                        if (s instanceof String) {
                            builder.append(indent).append("- \"").append(s).append("\"\n");
                        } else builder.append(indent).append("- ").append(s).append("\n");
                    }
                    continue;
                }
                if (value instanceof String) {
                    builder.append(indent).append(key).append(": \"").append(value).append("\"\n");
                } else builder.append(indent).append(key).append(": ").append(value).append("\n");

            }
        }
    }
}
