package net.t2code.t2codelib.SPIGOT.system.cmd;

import net.t2code.t2codelib.SPIGOT.api.commands.T2C_Cmd;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Template;
import net.t2code.t2codelib.SPIGOT.api.update.T2C_UpdateAPI;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.io.IOException;

public class Commands {
    protected static void info(CommandSender sender) {
        assert T2C_Main.getPlugin().getDescription().getDescription() != null;
        T2C_Template.sendInfo(sender, T2C_Main.getPlugin(), T2C_Util.getSpigotID(), T2C_Util.getDiscord(), null, T2C_Util.getInfoText().replace("[getDescription()]",T2C_Main.getPlugin().getDescription().getDescription()));
    }

    protected static void test(CommandSender sender, String[] args) {
        T2C_Send.sender(sender, T2C_Util.getPrefix() + " &4Currently there is no development test command");
    }

    protected static void debug(CommandSender sender, String[] args) {
        if (args.length < 2) {
            T2C_Send.sender(sender, "§4Use: §7/t2code debug createReportLog");
            return;
        }
        switch (args[1].toLowerCase()) {
            case "createreportlog":
                switch (args.length) {
                    case 2:
                        if (sender instanceof Player) {
                            T2C_Send.sender(sender, "<dark_red>The debug zip file is <red>automatically uploaded</red> to T2Code's servers<br>and <red>automatically deleted</red> " +
                                    "after <red>14</red> days!<br>The file can also be deleted manually by you via command!</dark_red><br><dark_green><hover:show_text:'<yellow>Confirm the" +
                                    " upload</yellow>'><click:run_command:'/t2c debug createReportLog confirmupload'>upload</click></hover></dark_green> <dark_gray>|</dark_gray> " +
                                    "<gold><hover:show_text:'<red>Do not upload</red>'><click:run_command:'/t2c debug createReportLog noupload'>keep the file on your server</click></hover></gold>");
                        } else T2C_Send.sender(sender, "<dark_red>The debug zip file is <red>automatically uploaded</red> to T2Code's servers</dark_red>" +
                                "<br><dark_red>and <red>automatically deleted</red> after <red>14</red> days!</dark_red>" +
                                "<br><dark_red>The file can also be deleted manually by you via command!</dark_red>" +
                                "<br><green>Confirm the upload with the command:</green>" +
                                "<br><yellow>/t2c debug createReportLog confirmupload</yellow>" +
                                "<br><red>Keep the file on your server and do not upload it with the command:</red>" +
                                "<br><yellow>/t2c debug createReportLog noupload</yellow>");
                        break;
                    case 3:
                        Boolean upload = args[2].equalsIgnoreCase("confirmupload");
                        Bukkit.getScheduler().runTaskAsynchronously(T2C_Main.getPlugin(), new Runnable() {
                            @Override
                            public void run() {
                                try {
                                    CreateReportLog.create(sender, upload);
                                } catch (IOException e) {
                                    T2C_Send.sender(sender, T2C_Util.getPrefix() + " <red>An error occurred while creating a report log! Please look in the console!</red>");
                                    throw new RuntimeException(e);
                                }
                            }
                        });
                        break;
                    default:
                        T2C_Send.sender(sender, "§4Use: §7/t2code debug createReportLog");
                        return;
                }
                break;
            case "deletereportlog":
                if (args.length != 3) {
                    T2C_Send.sender(sender, "§4Use: §7/t2code debug deleteReportLog [id]");
                    return;
                }
                try {
                    CreateReportLog.delete(args[2], sender);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
                break;
            default:
                T2C_Send.sender(sender, "§4Use: §7/t2code debug createReportLog/deleteReportLog");
                break;
        }
    }

    protected static void updateInfo(CommandSender sender, String[] args) {
        T2C_Send.sender(sender, T2C_UpdateAPI.updateInfo(args, sender instanceof Player));
    }

    public static void permtoggle(CommandSender sender, String[] args) {
        Player player = (Player) Bukkit.getOfflinePlayer(args[1]);
        if (player == null) {
            T2C_Send.sender(sender, "§4Player §6" + args[1] + " §4not exist!");
            return;
        }
        String permission = args[2];

        if (player.hasPermission(permission)) {
            T2C_Cmd.console(String.valueOf(T2C_LibConfig.VALUES.commandPermToggleCommand.getValue()).replace("[player]",player.getName()).replace("%player_name%",player.getName()).replace("[perm]",permission).replace("[value]", "false"));
            T2C_Send.sender(sender, "§2Permission §8'§6" + permission + "§8' §2was set to §6false §2for the player §6" + player.getName() + "§2.");
        } else {
            T2C_Cmd.console(String.valueOf(T2C_LibConfig.VALUES.commandPermToggleCommand.getValue()).replace("[player]",player.getName()).replace("%player_name%",player.getName()).replace("[perm]",permission).replace("[value]", "true"));
            T2C_Send.sender(sender, "§2Permission §8'§6" + permission + "§8' §2was set to §6true §2for the player §6" + player.getName() + "§2.");
        }


    }
}
