package net.t2code.t2codelib.VELOCITY.api.update;


import com.velocitypowered.api.plugin.PluginContainer;
import com.velocitypowered.api.proxy.ProxyServer;
import net.t2code.t2codelib.util.T2C_GenerateFrame;
import net.t2code.t2codelib.util.T2C_UpdateObject;
import net.t2code.t2codelib.util.T2C_UpdateWebData;
import net.t2code.t2codelib.util.T2C_UpdateType;
import net.t2code.t2codelib.VELOCITY.api.messages.T2CV_Send;
import net.t2code.t2codelib.VELOCITY.system.config.T2CV_LibConfig;
import org.slf4j.Logger;

import java.time.Duration;
import java.util.HashMap;

public class T2CV_UpdateAPI {
    public static HashMap<String, T2C_UpdateObject> bungeePluginVersins = new HashMap<>();

    public static void sendUpdateMsg(Logger logger, String prefix, String discord, T2C_UpdateWebData webData, PluginContainer plugin) {
        String publicVersion = webData.getVersion();
        String pluginVersion = plugin.getDescription().getVersion().orElse("unknown");
        String value;
        if (webData.isPreRelease()) {
            value = T2C_UpdateType.PRERELEASE_.text;
            if (publicVersion.toLowerCase().contains("dev")) {
                value = T2C_UpdateType.DEVELOPMENT_.text;
            }
            if (publicVersion.toLowerCase().contains("beta")) {
                value = T2C_UpdateType.BETA_.text;
            }
            if (publicVersion.toLowerCase().contains("snapshot")) {
                value = T2C_UpdateType.SNAPSHOT_.text;
            }
        } else value = T2C_UpdateType.STABLE_.text;
        String s1 = "A new [value] version was found!".replace("[value]", value);
        String s2 = "Your version: " + pluginVersion + " - Current version: " + webData.getVersion();
        String s3 = "You can download it here: " + webData.getUpdateUrl();
        String s4 = "You can find more information on Discord: " + discord;

        T2CV_Send.console(logger, T2C_GenerateFrame.getFrameCenter("[t2codelib]", true, s1, s2, s3, s4));
    }

    private static Boolean noUpdate = true;
    private static String pluginVersion;

    public static void onUpdateCheckTimer(Logger logger, PluginContainer plugin, ProxyServer server, String prefix, String discord, Integer spigotID, String url) {
        if ((int) T2CV_LibConfig.VALUES.updateTimer.getValue() < 1) {
            T2CV_LibConfig.VALUES.updateTimer.setValue(1);
        }

        server.getScheduler().buildTask(plugin, () -> {
            (new T2CV_UpdateCheckerGit(plugin, logger)).getVersion((webData) -> {
                pluginVersion = plugin.getDescription().getVersion().toString();
                T2C_UpdateObject update = new T2C_UpdateObject(
                        plugin.getDescription().getName().toString(),
                        plugin.getDescription().getVersion().toString(),
                        webData,
                        false,
                        !plugin.getDescription().getVersion().equals(webData.getVersion()),
                        true
                );
                bungeePluginVersins.put(plugin.getDescription().getName().toString(), update);
                if (!pluginVersion.replace("_Velocity", "").equalsIgnoreCase(webData.getVersion())) {
                    sendUpdateMsg(logger, prefix, discord, webData, plugin);
                    noUpdate = true;
                } else {
                    if (noUpdate) {
                        T2CV_Send.console(logger, " No update found.");
                        noUpdate = false;
                    }
                }
            }, pluginVersion, spigotID, url);

        }).repeat(Duration.ofMinutes((int) T2CV_LibConfig.VALUES.updateTimer.getValue())).schedule();
    }
}
